SystemOrganization addCategory: #PacMan!

TestCase subclass: #PacManTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacManTest methodsFor: 'actors' stamp: 'AgustinMosteiro 4/29/2013 20:09'!
blueGhost

	^Ghost new! !

!PacManTest methodsFor: 'actors' stamp: 'AgustinMosteiro 4/29/2013 20:15'!
blueberry

	^Fruit new! !

!PacManTest methodsFor: 'movements' stamp: 'AgustinMosteiro 4/29/2013 21:17'!
down

	^0 @ -1! !

!PacManTest methodsFor: 'construction block types' stamp: 'AgustinMosteiro 4/29/2013 21:23'!
ghostHouseDoorType

	^GhostHouseDoor new! !

!PacManTest methodsFor: 'movements' stamp: 'AgustinMosteiro 4/29/2013 21:16'!
left

	 ^-1 @ 0! !

!PacManTest methodsFor: 'construction block types' stamp: 'HernanWilkinson 5/16/2012 16:33'!
leftTransporterType

	self shouldBeImplemented ! !

!PacManTest methodsFor: 'actors' stamp: 'AgustinMosteiro 4/29/2013 20:12'!
pacman

	^Pacman new! !

!PacManTest methodsFor: 'movements' stamp: 'AgustinMosteiro 4/29/2013 21:16'!
right

	^1 @ 0! !

!PacManTest methodsFor: 'construction block types' stamp: 'AgustinMosteiro 4/29/2013 20:22'!
spaceType

	^Space new
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test01GhostCanNotGoIntoAWall

	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self right ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self up ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test02PacmanCanNotGoIntoAWall

	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:38'!
test02aFruitCanNotGoIntoAWall

	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self left ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self right ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self up ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test03GhostMovesIntoSpaces

	self assert: ( self blueGhost position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self left ).
	self assert: ( self blueGhost position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test04PacmanMovesIntoSpaces

	self assert: ( self pacman position + (-1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self left ).
	self assert: ( self pacman position +  (1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self right ).
	self assert: ( self pacman position +  (0@1) ) equals: ( self spaceType nextPositionFor: self pacman going: self up ).
	self assert: ( self pacman position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self pacman going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:39'!
test04aFruitMovesIntoSpaces

	self assert: ( self blueberry position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self left ).
	self assert: ( self blueberry position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test05GhostCanEnterHisHouse

	self assert: ( self blueGhost position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self left).
	self assert: ( self blueGhost position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test06PacmanCanNotEnterGhostHouse

	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:40'!
test06aFruitCanEnterHisHouse

	self assert: ( self blueberry position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self left).
	self assert: ( self blueberry position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test07GhostCanNotGoIntoTransporter

	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test08TransporterMovesPacmanToNewPosition

	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self left ).
	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:46'!
test09TransporterMovesFruitToNewPosition

	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self left ).
	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self right ).
! !

!PacManTest methodsFor: 'movements' stamp: 'AgustinMosteiro 4/29/2013 21:17'!
up

	^0 @ 1! !

!PacManTest methodsFor: 'construction block types' stamp: 'AgustinMosteiro 4/29/2013 20:09'!
wallType

	^Wall new! !

Object subclass: #Actor
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Actor methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 4/29/2013 21:11'!
nextPositionWhenMovingInto: aGostHouseDoor going: aDirection

	self shouldBeImplemented! !

Actor subclass: #Fruit
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Fruit methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 4/29/2013 21:19'!
initialize

	position := 0 @ 0! !

!Fruit methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 4/29/2013 20:15'!
position
	^position! !

Actor subclass: #Ghost
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Ghost methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 4/29/2013 21:18'!
initialize

	position := 0 @ 0! !

!Ghost methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 4/29/2013 21:42'!
nextPositionWhenMovingInto: aGhostHouseDoor going: aDirection 

	^aGhostHouseDoor nextPositionForTheGhost: self going: aDirection! !

!Ghost methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 4/29/2013 20:09'!
position

	^position! !

Actor subclass: #Pacman
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Pacman methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 4/29/2013 21:19'!
initialize

	position := 0 @ 0! !

!Pacman methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 4/29/2013 21:44'!
nextPositionWhenMovingInto: aGhostHouseDoor going: aDirection 

	^aGhostHouseDoor nextPositionForThePacman: self going: aDirection! !

!Pacman methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 4/29/2013 20:14'!
position
	^position! !

Object subclass: #Block
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Block methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 4/29/2013 20:34'!
nextPositionFor: aGhost going: aDirection

	self shouldBeImplemented! !

Block subclass: #GhostHouseDoor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!GhostHouseDoor methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 4/29/2013 21:27'!
nextPositionFor: anActor going: aDirection

	^anActor nextPositionWhenMovingInto: self going: aDirection! !

!GhostHouseDoor methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 4/29/2013 21:43'!
nextPositionForTheGhost: aGhost going: aDirection

	^aGhost position + aDirection! !

!GhostHouseDoor methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 4/29/2013 21:45'!
nextPositionForThePacman: aPacman going: aDirection

	^aPacman position! !

Block subclass: #Space
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Space methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 4/29/2013 21:43'!
nextPositionFor: anActor going: aDirection

	^anActor position + aDirection! !

Block subclass: #Wall
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Wall methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 4/29/2013 21:25'!
nextPositionFor: anActor going: aDirection

	^anActor position! !
